package blanco.xls;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

import junit.framework.TestCase;

public class BlancoXlsBookTest extends TestCase {
    public void testGenerate() throws Exception {
        final BlancoXlsBook book = new BlancoXlsBook();
        final BlancoXlsSheet sheet = book.createSheet("ABC");
        final BlancoXlsCell cell = sheet.getCell(1, 1);
        cell.setValue("");

        final File tmp = new File("./tmp");
        tmp.mkdirs();
        final OutputStream outStream = new BufferedOutputStream(
                new FileOutputStream(new File(tmp, "Test.xls")));
        try {
            book.save(outStream);
            outStream.flush();
        } finally {
            outStream.close();
        }
    }

    public void testMojibake() throws Exception {
        copyBook("BlancoCharacterGroupSampleHanKatakana.xls");
        copyBook("BlancoCharacterGroupSampleIbmKakutyouMoji.xls");
        copyBook("BlancoCharacterGroupSampleIso646Jp.xls");
        copyBook("BlancoCharacterGroupSampleJisX0201.xls");
        copyBook("BlancoCharacterGroupSampleNecSenteiIbmKakutyouMoji.xls");
        copyBook("BlancoCharacterGroupSampleNecTokusyuMoji.xls");
        copyBook("BlancoCharacterGroupSampleShiftJIS.xls");
        copyBook("BlancoCharacterGroupSampleZenHiragana.xls");
        copyBook("BlancoCharacterGroupSampleZenKatakana.xls");
    }

    void copyBook(final String fileName) throws Exception {
        final InputStream inStream = new FileInputStream("./test/data/"
                + fileName);

        final BlancoXlsBook bookRead = new BlancoXlsBook();
        bookRead.load(inStream);
        inStream.close();

        final BlancoXlsBook bookWrite = new BlancoXlsBook();
        final BlancoXlsSheet sheetWrite = bookWrite.createSheet("test");

        final BlancoXlsSheet sheetRead = bookRead.getSheetAt(0);

        for (int y = 14;; y++) {
            String no = sheetRead.getCell(0, y).getStringValue();
            if (no == null || no.length() == 0) {
                break;
            }

            sheetWrite.getCell(0, y).setValue(no);

            sheetWrite.getCell(1, y).setValue(
                    sheetRead.getCell(1, y).getStringValue());
            sheetWrite.getCell(2, y).setValue(
                    sheetRead.getCell(2, y).getStringValue());
        }

        final File tmp = new File("./tmp/copy");
        tmp.mkdirs();
        final OutputStream outStream = new BufferedOutputStream(
                new FileOutputStream(new File(tmp, "Copy" + fileName)));
        try {
            bookWrite.save(outStream);
            outStream.flush();
        } finally {
            outStream.close();
        }
    }
}
